// ============================================================================
// $Id: circle_protocol.hh,v 1.2 1996/04/26 23:33:04 questor Exp $
//
// This is part of Realm Of Magic
//
// Usage: Class that translates incoming messages into the circle protocol
//
// All rights reserved. See license.doc for complete information.
//
// Copyright (C) 1993-1996 by the Hackerz of the Realm Of Magic
// Realm Of Magic is based on CircleMUD, Copyright (C) 1993.
// CircleMUD is based on DikuMUD, Copyright (C) 1990, 1991.
// Original intermud_client.c (C) 1995, 96 by Chris Austin (Stryker@Tempus)
// Original lpc protocol (C) by Mark Lewis (Nostradamus@Zebedee)
//                           by J.W. Armstrong (Alvin@Sushi)
// ============================================================================

#ifndef __INTERMUD__CIRCLE_PROTOCOL_HH__
#define __INTERMUD__CIRCLE_PROTOCOL_HH__

#include "protocol.hh"
#include "imuddefs.hh"

class _circle : public _protocol {
private:
  dns_record muddns;

  virtual string TypeName() { return "Circle    "; }
  virtual string BasedOn() {
    return "   |     - This MUD is a Circle based MUD      "
           "                   |\n";
  }

  void IncomingInterwiz(string &);
  void IncomingIntertell(string &);
  void IncomingIntertellNR(string &);
  void IncomingInterwhoREQ(string &);
  void IncomingInterwho(string &);
  void IncomingInterpage(string &);
  void IncomingPingREP(string &, sockaddr_in &);
  void IncomingPingREQ(string &, sockaddr_in &);
  
public:
  void Startup();
  void OutgoingInterwiz(string &, string &);
  bool OutgoingIntertell(string &, string &, string &, string &);
  bool OutgoingIntertellNR(string &, string &, string &, string &);
  bool OutgoingInterwhoREQ(string &, string &);
  bool OutgoingInterwho(string &, string &, string &);
  bool OutgoingInterpage(string &, string &, string &, string &);
  void SendPings();
  virtual void PurgeList();
  bool IncomingMessage(string &, sockaddr_in &);
  
};

#endif  
