// ============================================================================
// $Id: intermud_comm.hh,v 1.2 1998/03/13 15:57:00 chris Exp $
//
// This is part of Realm Of Magic
//
// Usage: Definition of the Intermud network-functionality wrapper class
//
// All rights reserved. See license.doc for complete information.
//
// Copyright (C) 1993-1996 by the Hackerz of the Realm Of Magic
// Realm Of Magic is based on CircleMUD, Copyright (C) 1993.
// CircleMUD is based on DikuMUD, Copyright (C) 1990, 1991.
// ============================================================================

#ifndef __INTERMUD_COMM_HH__
#define __INTERMUD_COMM_HH__

#include <string>
#include <stdlib.h>
#include <stdio.h>
#include <iostream.h>
#include <iomanip.h>

#include <sys/types.h>
#include <sys/socket.h>
#include <sys/time.h>
#include <sys/resource.h>
#include <sys/un.h>
#include <netdb.h>
#include <fcntl.h>
#include <signal.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <unistd.h>

#include "intermud.hh"
#include "utils.hh"

struct bullet {
  int bytes;
};

class _intermud {
private:
  int intermud_socket;
  string out_data;
  string in_data;
  struct sockaddr_un intermud_server;
  int adress_length;
  bool connection;
  struct bullet bullet;

  // Low-level recv/send functionality

  int recv_data(char *);
  int send_data();

public:
  _intermud();
  void Connect();
  bool Connection();
  string ReceiveData();
  void FlushData();
  void CloseFD();
  string OutBuffer();
  int Desc();

  _intermud& operator<<(string);
  _intermud& operator<<(int);
  _intermud& operator<<(unsigned int);
  _intermud& operator<<(short int);
  _intermud& operator<<(unsigned short int);
  _intermud& operator<<(long int);
  _intermud& operator<<(unsigned long int);
  _intermud& operator<<(_intermud& (*pf)(_intermud&));

  friend _intermud& sendit(_intermud&);
};

#endif
